/**
 * DON'T USE THIS CODE IN PRODUCTION.
 * 
 * This was meant just to be used in the demo with minimal code and testing.
 */
(function () {

    var items = [],
        timeout,
        handler = function (e) {

            clearTimeout(timeout);

            // Delay the checks
            timeout = setTimeout(function () {

                var html = document.documentElement,
                    clientHeight = html.clientHeight,
                    clientRect,
                    visibleHeight,
                    index = items.length,
                    item;

                while (index--) {

                    item = items[index];
                    clientRect = item.element.getBoundingClientRect();
                    visibleHeight = (clientRect.height - 20);

                    if (clientRect.top >= visibleHeight * -1 && clientRect.bottom <= clientHeight + visibleHeight) {

                        item.callback(e);
                        
                        // Remove the element from the list of items as the callback is already
                        // executed
                        items.splice(index, 1);
                    }

                }

                // Unbind the events if there nothing to watch for
                if (!items.length) {
                    
                    window.removeEventListener("resize", handler, false);
                    window.removeEventListener("scroll", handler, false);
                }

            }, 500);
        };

    window.viewPortAction = {

        /**
         * Add elements to be checked when available on the viewport. Also add
         * callback to be executed when the element is on teh viewport.
         * 
         * @method add
         * @param {Element} element The HTML element to be checked
         * @param {Function} callback The function to be executed when on viewport
         */
        add: function (element, callback) {

            // Only bind the events when there is something to check
            if (!items.length) {

                window.addEventListener("resize", handler, false);
                window.addEventListener("scroll", handler, false);
            }

            items.push({
                element: element,
                callback: callback
            });

            // Call the handler right away to check it the element is already in the
            // viewport
            handler();
        }
    };

})();